/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Quadrato.h"
#include "tetris.h"

Quadrato::Quadrato()
{
	pos=0;
	movimento=true;
	quad1=new QuadratoStandard("quadratoBlu.bmp",Point(330,50));
	quad2=new QuadratoStandard("quadratoBlu.bmp",Point(350,50));
	quad3=new QuadratoStandard("quadratoBlu.bmp",Point(330,70));
	quad4=new QuadratoStandard("quadratoBlu.bmp",Point(350,70));	
}

void Quadrato::ruotaDx (Matrice Mat)
{
}

void Quadrato::scendi (Matrice Mat,int livello)
{

	cont++;
	if(cont>=10-livello)
	{
	
		cont=0;
	
	if(Mat.scendi(this->getPoint(),1)==true)
	{
	quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+1));
	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+1));
	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+1));	
	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+1));
	}
	else
	{
		tikcs++;
		if(tikcs >= 12)
			movimento=false;
	}
	}
}

void Quadrato::scendiVeloce(Matrice Mat)
{
	if(Mat.scendi(this->getPoint(),1)==true)
	{
	quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+1));
	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+1));
	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+1));	
	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+1));
	}
	else
	{
		movimento=false;
	}
	if(Mat.scendi(this->getPoint(),1)==true)
	{
	quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+1));
	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+1));
	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+1));	
	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+1));
	}
	else
	{
		movimento=false;
	}

	
}

void Quadrato::spostaDx(Matrice Mat)
{
	if(quad1->getLeftTopCorner().getY()%20==0)
	{
		if(Mat.spostaDx(this->getPoint())==true)
		{
			quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
			quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
			quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()+20,quad3->getLeftTopCorner().getY()));	
			quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()+20,quad4->getLeftTopCorner().getY()));
		}
	}
	else
	{
		if(Mat.spostaDx2(this->getPoint())==true)
		{
			quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()+20,quad1->getLeftTopCorner().getY()));
			quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX()+20,quad2->getLeftTopCorner().getY()));
			quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()+20,quad3->getLeftTopCorner().getY()));	
			quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()+20,quad4->getLeftTopCorner().getY()));
		}		
	}	
}

void Quadrato::spostaSx(Matrice Mat)
{
	if(Mat.spostaSx2(this->getPoint())==true)
	{
		quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX()-20,quad1->getLeftTopCorner().getY()));
		quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX()-20,quad2->getLeftTopCorner().getY()));
		quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX()-20,quad3->getLeftTopCorner().getY()));	
		quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX()-20,quad4->getLeftTopCorner().getY()));

	}	
}

void Quadrato::add(tetris* a) 
{
	a->add(DrawablePointer(*quad1));
	a->add(DrawablePointer(*quad2));	
	a->add(DrawablePointer(*quad3));	
	a->add(DrawablePointer(*quad4));
}


vector<Point> Quadrato::getPoint()
{

	vector<Point>temp;
	temp.push_back(quad1->getLeftTopCorner());
	temp.push_back(quad2->getLeftTopCorner());
	temp.push_back(quad3->getLeftTopCorner());
	temp.push_back(quad4->getLeftTopCorner());
	return temp;

}
void Quadrato::distruggiQuadrati (int Y,int X)
{
	if(quad1->getLeftTopCorner().getY()==Y*20+50)
	{	quad1->setDistruggi();
	}
	if(quad2->getLeftTopCorner().getY()==Y*20+50)
	{	quad2->setDistruggi();
	}
	if(quad3->getLeftTopCorner().getY()==Y*20+50)
	{	quad3->setDistruggi();
	}
	if(quad4->getLeftTopCorner().getY()==Y*20+50)
	{	quad4->setDistruggi();
	}
	if(quad1->getLeftTopCorner().getY()<Y*20+50)
	{											 
		quad1->setLeftTopCorner(Point(quad1->getLeftTopCorner().getX(),quad1->getLeftTopCorner().getY()+20));
	}
	if(quad2->getLeftTopCorner().getY()<Y*20+50 )
	{	quad2->setLeftTopCorner(Point(quad2->getLeftTopCorner().getX(),quad2->getLeftTopCorner().getY()+20));
	}	
	if(quad3->getLeftTopCorner().getY()<Y*20+50 )
	{	quad3->setLeftTopCorner(Point(quad3->getLeftTopCorner().getX(),quad3->getLeftTopCorner().getY()+20));
	}	
	if(quad4->getLeftTopCorner().getY()<Y*20+50 )
	{	quad4->setLeftTopCorner(Point(quad4->getLeftTopCorner().getX(),quad4->getLeftTopCorner().getY()+20));
	}
}
